<script setup lang="ts">
import { useStockStore } from '@/stores/stock'
import { useAuthStore } from '@/stores/auth'

import PrintDialog from './PrintDialog.vue'
import StockItemList from '@/components/StockComponent/StockItemList.vue'
import ReceiptStockDetailTable from './ReceiptStockDetailTable.vue'

import { onMounted, ref, watchEffect } from 'vue'
import type { Stock } from '@/types/Stock'
import type { ReceiptStockItem } from '@/types/ReceiptStockItem'

function showDateTime() {
  // show data and time in receipt
  const currentDate = new Date()
  // date components
  const year = currentDate.getFullYear()
  const month = currentDate.getMonth() + 1
  const day = currentDate.getDate()
  return `${year}-${month}-${day}`
}
function showTime() {
  // show data and time in receipt
  const currentDate = new Date()
  // time components
  const hours = currentDate.getHours()
  const minutes = currentDate.getMinutes()
  const seconds = currentDate.getSeconds()
  return `${hours}:${minutes}:${seconds}`
}
const stockStore = useStockStore()
const authStore = useAuthStore()
const Idtax = ref('')
const namePlace = ref('')
const dialogRe = ref(false)
const noItem = ref(false)
const noIDandNAME = ref(false)
const noPrice = ref(false)
const total = ref()
const isTextFieldDisabled = ref(false)
function selected(s: Stock) {
  console.log('Insert receiptItem ' + s)
  stockStore.addStockItem(s)
}
function enterIdTax() {
  console.log('Enter Id Tax')

  stockStore.receiptStock.idreceipt = Idtax.value
}
function enterNamePlace() {
  console.log('Enter Name place')
  stockStore.receiptStock.nameplace = namePlace.value
}
function clearIdText() {
  Idtax.value = ''
}
function clearNameText() {
  namePlace.value = ''
}
function clearThis() {
  clearIdText()
  clearNameText()
  stockStore.dialogRe = !stockStore.dialogRe
  stockStore.addReceiptStock()
  stockStore.clear()
  stockStore.dialogImportM = false
}
function closeThis(){
  clearAll()
  stockStore.dialogImportM = !stockStore.dialogImportM
}
function clearAll() {
  stockStore.clear()
  clearIdText()
  clearNameText()
}
function showReceipt() {
  if (
    stockStore.receiptStockItems.length >= 1 &&
    stockStore.receiptStock.idreceipt != '' &&
    stockStore.receiptStock.nameplace != '' &&
    stockStore.receiptStock.total > 0
  ) {
    stockStore.showReceiptImport()
  } else if (stockStore.receiptStockItems.length < 1) {
    noItem.value = !noItem.value
  } else if (stockStore.receiptStock.idreceipt == '' || stockStore.receiptStock.nameplace == '') {
    noIDandNAME.value = !noIDandNAME.value
  } else {
    noPrice.value = !noPrice.value
  }
}
function addBalance() {
  console.log('Add balance')
  for (const item of stockStore.receiptStockItems) {
    stockStore.addBTest(item)
  }

  // const index = stockStore.receiptStockItems.findIndex((item) => item.stock?.name === s.name &&
  // item.stock?.minimum ===s.minimum &&
  // item.stock?.price ===s.price &&
  // item.stock?.unit ===s.unit )
}
function toggleTextField() {
  isTextFieldDisabled.value = !isTextFieldDisabled.value
}
//  watchEffect(() => {
//   // Check if the value is not empty
//   if (stockStore.receiptStock.total!== null && stockStore.receiptStock.total !== undefined && stockStore.receiptStock.total !== 0) {
//     // Optionally, you can perform any additional actions here
//     // For example, clear the value after a brief delay
//     setTimeout(() => {
//       clearTxtField();
//     }, 1000); // Clear the value after 1000 milliseconds (1 second)
//   }
// });
</script>
<template>
  <v-dialog
    v-model="stockStore.dialogImportM"
    fullscreen
    :scrim="false"
    transition="dialog-bottom-transition"
  >
    <v-card>
      <v-toolbar dark color="#403c3c">
        <v-btn icon dark @click="closeThis()">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Import Stock</v-toolbar-title>
        <v-spacer></v-spacer>
      </v-toolbar>

      <v-row>
        <v-col cols="12" md="5" style="padding-top: 40px; padding-left: 200px">
          <v-container style="padding: 0.1%; padding-top: 2%;">
            <v-sheet
              min-width="300"
              max-width="800"
              height="220"
              elevation="0"
              style="border: 2px solid black; background-color: rgb(255, 255, 255)"
            >
              <v-row style="height: 50px">
                <!-- ใส่ใบกำกับภาษี  -->
                <div
                  style="padding-top: 10px; margin-bottom: 10px; padding-left: 12px; height: 0px"
                >
                  รหัสใบเสร็จ
                </div>
                <v-col cols="6" no-gutters>
                  <div>
                    <v-text-field
                      style="margin-left: 0%"
                      density="compact"
                      v-model="Idtax"
                      :rules="[(v) => !!v || 'Field is required']"
                      :disabled="isTextFieldDisabled"
                      @keyup.enter="enterIdTax()"
                      append-inner-icon="mdi-send"
                      @click:append-inner="enterIdTax()"
                    ></v-text-field></div
                ></v-col>
              </v-row>

              <v-row>
                <!-- ใส่ชื่อสถานที่ -->
                <div style="padding-top: 10px; padding-bottom: 10px; padding-left: 12px">
                  สถานที่ซื้อ
                </div>
                <v-col cols="6" no-gutters>
                  <div>
                    <v-textarea
                      style="margin-left: 2%"
                      density="compact"
                      v-model="namePlace"
                      @keyup.enter="enterIdTax()"
                      :rules="[(v) => !!v || 'Field is required']"
                      append-inner-icon="mdi-send"
                      @click:append-inner="enterNamePlace()"
                    ></v-textarea></div
                ></v-col>
              </v-row> </v-sheet
          ></v-container>

          <v-sheet
            min-width="300"
            max-width="800"
            height="600"
            elevation="0"
            style="border: 2px solid black; background-color: rgb(255, 255, 255)"
          >
            <div style="text-align: center; font-size: 30px">สินค้า</div>
            <StockItemList
              :s-items="stockStore.stockLows"
              @selected-s-item="selected"
            ></StockItemList>
          </v-sheet>
        </v-col>
        <v-col cols="12" md="7">
          <v-container style="padding: 0">
            <v-row>
              <v-col cols="12" style="padding: 5px; padding-top: 20px">
                <div style="text-align: center; font-size: 30px">ออเดอร์ สินค้า</div>
                <v-sheet
                  min-width="300"
                  max-width="820"
                  height="350"
                  elevation="6"
                  style="border: 2px solid black"
                  class="overflow-auto"
                >
                  <ReceiptStockDetailTable></ReceiptStockDetailTable>
                </v-sheet>
              </v-col>
              <v-col cols="12" style="padding: 5px">
                <v-sheet
                  min-width="300"
                  max-width="820"
                  height="150"
                  elevation="6"
                  style="border: 2px solid black"
                >
                  <div style="font-size: 30px; text-align: left; margin-top: 50px; margin-left: 30px">
                    Total Price:{{ stockStore.receiptStock.total }}
                  </div>

                  <v-row no-gutters>
                    <v-col cols="6" style="padding-top: 5px">
                      <div>
                        <v-btn prepend-icon="" style="margin-left: 610px;  background-color: red; color: white;" @click="clearAll()"
                          >Cancel</v-btn
                        >
                      </div></v-col
                    >
                    <v-col cols="6" style="padding-top: 5px">
                      <div>
                        <v-btn prepend-icon="" style="margin-left: 300px; background-color: #47bb59; color: white;" @click="showReceipt()"
                          >Confirm</v-btn
                        >
                      </div></v-col
                    >
                  </v-row>
                </v-sheet>
              </v-col>
            </v-row>
          </v-container>
        </v-col>
      </v-row>
    </v-card>
  </v-dialog>

  <!-- Dialog โชว์ใบเสร็จ -->
  <v-dialog v-model="stockStore.dialogRe" persistent width="auto" height="auto" scrollable>
    <v-card>
      <v-card-title>ใบสั่งซื้อ</v-card-title>
      <v-card-text justify="center" align="center" style="border: 1px solid">
        <!-- head -->
        <!-- รายละเอียดส่วนข้างบน -->
        <v-container>
          <v-row justify="center">สถานที่ซื้อ: {{ stockStore.receiptStock.nameplace }}</v-row>
          <v-row style="font-size: 10px">-----------------------------------------------</v-row>
          <v-row style="font-size: 10px">วันที่:{{ stockStore.textDate[0] }}</v-row>
          <v-row style="font-size: 10px">เวลา:{{ stockStore.textDate[1] }}</v-row>
          <v-row style="font-size: 10px">พนักงาน:{{ authStore.getCurrentUser()?.fullName}}</v-row>
          <v-row style="font-size: 10px">ใบกำกับภาษี:{{ stockStore.receiptStock.idreceipt }}</v-row>
          <br />
        </v-container>

        <v-divider></v-divider>
        <!-- ตาราง -->
        <v-container class="pa-0">
          <v-table density="compact">
            <thead>
              <tr style="font-size: 10px; text-align: left">
                <th>รายการ</th>
                <th>จำนวน</th>
                <th>ราคา</th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="item of stockStore.receiptStockItems"
                :key="item.id"
                style="font-size: 10px; text-align: left"
              >
                <td>{{ item.name }}</td>
                <td>{{ item.unitPerItem }}</td>
                <td>{{ item.totalprice }} ฿</td>
              </tr>
            </tbody>
          </v-table>
        </v-container>
        <v-divider></v-divider>
        <!-- รายละเอียด -->
        <v-container class="pa-0" style="width: 300px">
          <v-row no-gutters>
            <v-col cols="12">-----------------------------------------------</v-col>
            <v-col cols="6" style="font-size: 11px; text-align: left"
              ><p>รวมเงินทั้งหมด: {{ stockStore.receiptStock.total }}</p></v-col
            >

            <v-col cols="12">-----------------------------------------------</v-col>
          </v-row>
        </v-container>
        <v-divider></v-divider>
        <p style="font-size: 11px; padding-top: 10px">ขอบคุณที่ใช้บริการค่ะ</p>
      </v-card-text>
      <v-card-actions>
        <v-spacer> </v-spacer>
        <v-btn @click="stockStore.dialogRe = !stockStore.dialogRe">ยกเลิก</v-btn>
        <v-btn @click="clearThis()">ยืนยัน</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- dialog เมื่อยังไม่ใส่ID และ  NAME -->
  <v-dialog v-model="noIDandNAME" width="250">
    <template v-slot:default="{ isActive }">
      <v-card title="Warning">
        <v-card-text> You didn't insert ID tax and Name Place </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
        </v-card-actions>
      </v-card>
    </template>
  </v-dialog>
  <!-- dialog ไม่ใส่สินค้า -->
  <v-dialog v-model="noItem" width="250">
    <template v-slot:default="{ isActive }">
      <v-card title="Warning">
        <v-card-text> You didn't insert Stock Items </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
        </v-card-actions>
      </v-card>
    </template>
  </v-dialog>
  <!-- dialog เมื่อยังไม่ใส่Price -->
  <v-dialog v-model="noPrice" width="250">
    <template v-slot:default="{ isActive }">
      <v-card title="Warning">
        <v-card-text> You didn't insert Price </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>

          <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
        </v-card-actions>
      </v-card>
    </template>
  </v-dialog>
</template>
<style scoped>
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}
.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
